# Logbook 

## 07/03 - Logbook 1 

#### **Searches & Results :**

Implementation of the administrative side of the project (gitlab repository).

Exploring existing models, focusing on these presented in [Model Checking Contest 2022](https://mcc.lip6.fr/2022/).  

Discovering [Tappal](https://www.tapaal.net/), tools which allow to check propreties using CTL formula over Petri Net.  

[Tools](https://www2.informatik.uni-hamburg.de/TGI/PetriNets/tools/quick.html) based on petri net.  


#### **Goals :**

The objective of this first real week of work was to **understand the main resource** of our subject as well as to start **looking at the tools** available, as well as their operation in a very fast way.

#### **Goals for the next session:**

The goals for the next week are:

- Understand the tools a little more in depth.
- Discover more tools.
- Link the tools with the CTL notions that interest us (limits...)
- Produce results using these tools.
- Start writing the report.
- Prepare presentation slides.

## 14/03 - Logbook 2

Presentation day :

- Presentation of the ressource
- Recall CTL (cardinality/Fireability)
- Recall Petri Nets
- Tool 1 + concrete example (Tapaal)
- Tool 2 (GreatSPN)

#### **Searches & Results :**

**MR** :  

2 categories for CTL in Model Checking Contest : CTL Cardinality and CTL Fireability  
[Simplification of CTL Formulae for Efficient Model Checking of Petri Nets](https://homes.cs.aau.dk/~srba/files/BDJJS:PN:18.pdf) : Tapaal base implementation paper  
Create simple concrete exemple for presentation  
Choose tool for main study : Tapaal  

**ML** :  

Recall Petri Nets

Recall CTL

CTL syntax

Extended syntax

CTL semantics

Petri nets & CTL :

In our case, most of the tools will take petri nets as arguments and we will be able to verify properties using CTL. Two important properties can be noted:

- CTLCardinality : Obtain the marking of a Petri net using a CTL query.
- CTLFireability : check with a CTL query if a transition is fireable.

Description of the ressource : 

Website of Model Checking Contest.

Annual competition that aims to promote the development and advancement of techniques and tools for model checking, a formal verification method used to check if a system satisfies a set of specifications or requirements.

The competition has different categories, including sequential and concurrent systems, hardware and software verification, and bounded and unbounded model checking. The winners of each category are determined based on the accuracy and efficiency of their tools or techniques.

**The results for 2022 will interest us.**

#### **Goals :**

The goals for this week are :

- Start report and gantt chart.
- Overview of tools
- Focus CTL, what is the purpose of these tools, what are the atomic proposals that we see on the PNs (there are two categories in the Contest, why)
- A concrete example with for example tapaal

#### **Goals for the next session:**

- Continue the report.
- Undestand tools, can we link tools by functionalities?a tool superior to the others? performance?

#### **New resources**

SMV Course.  
https://homes.cs.aau.dk/~srba/files/BDJJS:PN:18.pdf
Tapaal website : https://www.tapaal.net/

## 21/03 - Logbook 2

#### **Searches & Results :**

**MR** :  

Exploring models used during the Model Checking Contest 2022 : 
- Representing real-life situation, may depend on parameters which gives number of places and transitions (exemple : number of philosopher in Dining philosophers problem)  
- CTL formula are generated by [Citili](https://github.com/mcc-petrinets/citili) (lack of documentation)

Start reading [Simplification of CTL Formulae for Efficient Model Checking of Petri Nets](https://homes.cs.aau.dk/~srba/files/BDJJS:PN:18.pdf)  

Search about : 
- Structural reduction
- Stubborn sets  

**ML** :  

Writing of the first two parts of the report:

1. Introduction  

1.1 Motives  

1.2 Objectives

2.Background  

2.1 Petri Net  

2.2 CTLs  

2.3 MCC  

#### **Goals :**

- Start completing the rapport with information presented last-week
- Start the search about processing used by model checking tools with CTL.

#### **Goals for the next session:**

- Continue search and documenting it
- Continue the rapport

#### **New resources**

Several mentioned in the report for the writing of the introduction in particular.  
https://github.com/mcc-petrinets/citili

## 28/03 - Logbook 3

#### **Searches & Results :**

**MR** :  

Choose a well-know exemple used during MCC : [Dining philosophers model](https://mcc.lip6.fr/2022/pdf/Philosophers-form.pdf)
- Allow variable number of philosopher
- Model Shared Ressource Problem

Search about CTL and Petri Net : 
- [Characterizing Petri Nets with the Temporal Logic CTL](https://www.atlantis-press.com/proceedings/citcs-12/3043) : describe CTL for Reachability, Boundedness, Liveness, Reversibility, Coverability and Persistence 
- [Petri Net Based CTL Model Checking: Using a New Method to Construct OBDD Variable Order](https://ieeexplore.ieee.org/document/9546813) : Learn about OBDD for CTL model checking
- [Simplification of CTL Formulae for Efficient Model Checking of Petri Nets](https://homes.cs.aau.dk/~srba/files/BDJJS:PN:18.pdf) : Propose CTL formula simplification


**ML** :  

Establishment of a formalism allowing the reproducibility of the examples mentioned in the report, for more details, see report section.

#### **Goals :**

- Develop a document format allowing external stakeholders to reproduce our examples.
- Choose a fairly complex example and develop it with Tapaal.

#### **Goals for the next session:**

- Choose the important concepts to be covered during the presentation.
- Clarify the use of examples, which examples to take and why ? (Choose several examples to highlight the features of Tapaal.)

#### **New resources**

Philosophers : https://mcc.lip6.fr/2022/pdf/Philosophers-form.pdf.  
https://www.atlantis-press.com/proceedings/citcs-12/3043.  
https://ieeexplore.ieee.org/document/9546813.  
https://homes.cs.aau.dk/~srba/files/BDJJS:PN:18.pdf.  

## 04/04 - Logbook 4

#### **Searches & Results :**

**MR** :  

Explore models used during the MCC and their CTL formula.  
Search about common Petri Net properties which can be verified with CTL formula.
Create model and performance visuals for the presentation.     

**ML** :  

Documentation of the example of the philosophers (filling the document).
Added document to reference Tapaal features.

#### **Goals :**

- Setting up a reproducible example with Tapaal. This includes a procedure file to reproduce the provided example. Non-final if not enough time.
- Present an example in a complete way. This includes creating on Tapaal, exploring the functionality possible with this example, and things that are impossible to do/prove. Take another example if the one proposed does not make it possible to implement the limits of Tapaal.
- Test one or more Tapaal limits. Loop ? PN with a large number of states and transitions ?
- Little teaser : Setting up a counterexample with GreatSPN ?
- Advance the report. Keep a written record of the important work carried out, in particular the points mentioned above.

#### **Goals for the next session:**

- Talking about GreatSPNL.

#### **New resources**

## 11/04 - Logbook 5

#### **Searches & Results :**

**MR** :  

Read about : 
- [Stubborn set method](https://link.springer.com/article/10.1007/s10703-006-0006-1)
- [Reduction and expansion of live and safe marked graphs](https://ieeexplore.ieee.org/stamp/stamp.jsp?tp=&arnumber=1084711) (probably not usefull here)
- [Occam’s Razor Applied to the Petri Net Coverability Problem](https://arxiv.org/abs/1607.05956) Coverability problem, usefull for CTL

**ML** :  

Schema of project objectives.  

Partially complete Tapaal "manual".  

Partially complete the report.

#### **Goals :**

- Have detail on optimization method used in CTL model checking
- Summarize the project objectives with a diagram.
- Partially complete the Tapaal "manual". Take inspiration from an existing manual.
- Continue the report.

#### **Goals for the next session:**

Check on the known limits

#### **New resources**

## 18/04 - Logbook 6

Presentation day :
- Summary of project objectives (diagram).
- Tapaal Manual ("Tapaal - User Manual").
- Example of philosophers with Tapaal (3 examples, choose the number of philosophers).
- Have detail on optimization method used in CTL model checking
- Talk about important Tapaal features or related to model checking ("verify query", "Net stats", "bath processing")
- Talk about the formalism to make the examples reproducible ("Tapaal - Examples").

#### **Searches & Results :**

**MR** :  

Specific lookup about limit, logical ones : 
- Space
- Time

**ML** :  

Finish the Tapaal manual. See "report/manual/"Tapaal - User Manual"

#### **Goals :**

- Have detail on optimization method used in CTL model checking
- Summarize the project objectives with a diagram.
- Have a complete Tapaal manual.

#### **Goals for the next session:**

Check on the known limits

#### **New resources**

The objectives for the last two weeks were more or less defined during the previous presentation. So, here are the points to be discussed during the next presentation, which will define the objectives for the remaining days:

- Talking about GreatSPN. Similarities and differences with Tapaal. Show the example of the counter-example, i.e. the correction of a wrong CTL formula directly by GreatSPN.
- Understand the algorithm used by Tapaal. After the steps of simplications, we consider an automaton $A$ with a set of states and transitions, how does Tapaal verify the CTL formulas?
- Practical case of deadlock: it is possible to know if an automaton is in deadlock or not, does Tapaal give us indications on this state?

## 25/04 - Logbook 7

#### **Searches & Results :**

**MR** :  

Improved [reduction rules](https://github.com/TAPAAL/verifypn/blob/main/Documentation/new-reductionsABCDE-documentation.pdf) of verifypn (fast untimed engine for TAPAAL)  
Presentation of TAPAAL : [TAPAAL: Editor, Simulator and Verifier of Timed-Arc Petri Nets](https://homes.cs.aau.dk/~srba/files/BJS:ATVA:09.pdf)  
[ITS-CTL](https://github.com/lip6/ITS-CTL) Model checker for CTL

**ML** :  

Find the well states in Tapaal.

#### **Goals :**

- Search about algorithms used in Tapaal

#### **Goals for the next session:**


#### **New resources**

## 02/05 - Logbook 8

#### **Searches & Results :**

**MR** :  

Solving problems with opening pdfs on gitlab.

**ML** :  

Start using GreatSPN in "depth". Established a partially completed list of similarities and differences with Tapaal.

Complete the various documents related to the project.

Solving problems with opening pdfs on gitlab.

#### **Goals :**


#### **Goals for the next session:**


#### **New resources**


## 09/05 - Logbook 8

Presentation Day

#### **Searches & Results :**

**MR** :  

[UPAAL](https://uppaal.org/) model checking engine for Network of Timed Automata, TAPAAL model can be converted into UPAAL model.  
[Dependency Graph for verification](https://link.springer.com/article/10.1007/s10009-020-00578-9) Used by TAPAAL to verify CTL on Petri Net  
[Efficient Model-Checking of Weighted CTL with Upper-Bound Constraints](https://homes.cs.aau.dk/~srba/files/JLSO:STTT:14.pdf) CTL model cheking with Dependency Graph  


**ML** :  

Finish completing the documents related to our project.

Research on the basic algorithm of CTL checks.

#### **Goals :**

- Talking about GreatSPN.
    - Initially, a detailed comparison of the similarities and differences between GreatSPN and Tapaal was wanted. We will settle for one or two things possible with GreatSPN and impossible with Tapaal and vice versa.
- Finish completing the documents related to our project
- Have a complete and fairly accurate Gantt chart.
- Prepare the presentation
    - Gantt chart
    - Talk about different documents
    - Special case: Tapaal gives us the CTL request for the deadlock, does it also give the deadlock state? Solution if not? (make your own query, we know that "verify query" gives us the drawn transitions.)
    - CTL algorithm used by Tapaal for query checking.
    - Talking about discoveries with GreatSPN
    - What has this project brought us


#### **New resources**



## 16/05 - Logbook 10

## 23/05 - Logbook 11

## 30/05 - Logbook 12

#### **Searches & Results :**

**MR** :  

Complete Tapaal examples with home construction example.  
[A CTL* Model Checker for Petri Nets](https://www.ncbi.nlm.nih.gov/pmc/articles/PMC7324216/) Desribe RGMEDD* , the CTL* model checker of GreatSPN.  


**ML** :  

## 06/06 - Logbook 13

Presentation Day

#### **Searches & Results :**

**MR** :  

Complete subpart of report 


**ML** :  